package com.yc.ship.module.miniapplet.service.catalogue;

import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.miniapplet.controller.admin.catalogue.vo.CataloguePageReqVO;
import com.yc.ship.module.miniapplet.controller.admin.catalogue.vo.CatalogueRespVO;
import com.yc.ship.module.miniapplet.controller.admin.catalogue.vo.CatalogueSaveReqVO;
import com.yc.ship.module.miniapplet.dal.dataobject.catalogue.CatalogueDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 目录类型 Service 接口
 *
 * @author 管理员
 */
public interface CatalogueService {

    /**
     * 创建目录类型
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCatalogue(@Valid CatalogueSaveReqVO createReqVO);

    /**
     * 更新目录类型
     *
     * @param updateReqVO 更新信息
     */
    void updateCatalogue(@Valid CatalogueSaveReqVO updateReqVO);

    /**
     * 删除目录类型
     *
     * @param id 编号
     */
    void deleteCatalogue(Long id);

    /**
     * 获得目录类型
     *
     * @param id 编号
     * @return 目录类型
     */
    CatalogueDO getCatalogue(Long id);

    /**
     * 获得目录类型
     *
     * @param id 编号
     * @return 目录类型
     */
    CatalogueRespVO getCatalogueResp(Long id);

    /**
     * 获得目录类型分页
     *
     * @param pageReqVO 分页查询
     * @return 目录类型分页
     */
    PageResult<CatalogueDO> getCataloguePage(CataloguePageReqVO pageReqVO);

    List<CatalogueDO> getCatalogueList(Collection<Long> ids);

    /**
     * 查目录类型树
     *
     * @return
     */
    List<Map<String, Object>> getCatalogueTree();

    List<CatalogueDO> getCatalogueListByStatus(Integer status);

    CatalogueDO getByCode(String code);
}
